#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2eight4search.py">
#<abstract4xi abstract = "shoots to direction eight"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2eight4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2eight4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2eight4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4eight

global count2ack4eight
global count2nack4eight
global count2found4eight
global count2short4eight

global current2series4eight
global candidate2series4eight

global fileobject4eight  

global keys2profile4eight
global key2profile4eight

global left2find4eight

global maxsize2ack4eight    
global maxsize2file4eight 
global max2short4eight
global meansize2ack4eight
global minsize2ack4eight

global eight2analyse4search

global profile2fetch4eight

global right2find4eight

global sumsize2ack4eight    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4eight = VersionKB4Xi['base2shoot4eight']             # base internet address, None=local url

count2ack4eight   = 0
count2nack4eight  = 0
count2found4eight = 0
count2short4eight = 0

left2find4eight = '('

max2short4eight = VersionKB4Xi['max2short4eight']
maxsize2file4eight = VersionKB4Xi['maxsize2file4eight']
maxsize2ack4eight  = 0
meansize2ack4eight = 0
minsize2ack4eight  = 0

current2series4eight = "current2series4eight5dummy"
candidate2series4eight  = "candidate2series4eight5dummy"


eight2analyse4search  = VersionKB4Xi['eight2analyse4search']

profile2fetch4eight = {}
profile2fetch4eight [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4eight [2] = '.jpg'
keys2profile4eight = profile2fetch4eight.keys()

right2find4eight = ')'

sumsize2ack4eight  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4eight" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4eight(target2explore4eight):
    global count2ack4eight
    global count2nack4eight
    global count2found4eight
    global count2short4eight
    
    global fileobject4eight 
       
    global keys2profile4eight
    global key2profile4eight
    
    global left2find4eight

    global max2short4eight    
    global maxsize2file4eight     
    global maxsize2ack4eight    
    global meansize2ack4eight
    global minsize2ack4eight
  
    global candidate2series4eight
    global current2series4eight
    
    
    global profile2fetch4eight                         # extension for files
    
    global right2find4eight
    
    global sumsize2ack4eight    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4eight = count2found4eight + 1
    ack2debug4eight = True                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4eight)
    
    ack2profile = False
    for key2profile4eight in keys2profile4eight:
        if name2target[1] == profile2fetch4eight[key2profile4eight]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2EIGHT4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4eight
        if ack2debug4eight is True:
            print("(STEP 0A/33) OF SHOOT2EIGHT4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2EIGHT4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4eight:
            count2nack4eight = count2nack4eight + 1
        else:
            count2ack4eight = count2ack4eight + 1
            sumsize2ack4eight = sumsize2ack4eight + size2file
            if size2file > maxsize2ack4eight:
                maxsize2ack4eight = size2file
            if ((size2file < minsize2ack4eight) or (minsize2ack4eight == 0)):
                print("(STEP 0B/33) OF SHOOT2EIGHT4SEARCH - USING MINSIZE2ACK4EIGHT: ", minsize2ack4eight, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4EIGHT:  0  SIZE2FILE:  402715  PATH2INPUT:  O://temp//yophotos//test2eight//l\linnustus\linnustus31lokakuuta2012\linnustus31lokakuuta2012 (1).JPG
                # SET MINSIZE2ACK4EIGHT TO:  402715  = SIZE2FILE:  402715  PATH2INPUT:  O://temp//yophotos//test2eight//l\linnustus\linnustus31lokakuuta2012\linnustus31lokakuuta2012 (1).JPG
                minsize2ack4eight = size2file
                print("(STEP 0C/33) OF SHOOT2EIGHT4SEARCH - SET MINSIZE2ACK4EIGHT TO: ", minsize2ack4eight, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4EIGHT TO:  352249  = SIZE2FILE:  352249  PATH2INPUT:  O://temp//yophotos//test2eight//l\linnustus\linnustus31lokakuuta2012\linnustus31lokakuuta2012 (10).JPG
                # SET MINSIZE2ACK4EIGHT TO:  88827  = SIZE2FILE:  88827  PATH2INPUT:  O://temp//yophotos//test2eight//l\linnustus\linnustus31lokakuuta2012\linnustus31lokakuuta2012 (32).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4eight = target2explore4eight
            if ack2debug4eight is True:print("(STEP 1A/33) OF SHOOT2EIGHT4SEARCH - URL2WEB4EIGHT: ", url2web4eight) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4eight,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4eight = url2web4eight[0:index2edit] + string2use + url2web4eight[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4eight)
            shortname2web4eight = name2web[0]
            if ack2debug4eight is True:
                print("(STEP 1B/33) OF SHOOT2EIGHT4SEARCH - SHORTNAME2WEB4EIGHT: ", shortname2web4eight)
                # 
            
            string2find4eight = '/'
            ackall2found4eight = False           
            while 1:
                if ackall2found4eight is True:
                    break
                else:
                    index2find4eight=str.find(shortname2web4eight,string2find4eight)   
                    if index2find4eight == -1:
                        ackall2found4eight = True
                    else:
                        shortname2web4eight = shortname2web4eight[index2find4eight+1:]
                        
            if ack2debug4eight is True:            
                print("(STEP 1C/33) OF SHOOT2EIGHT4SEARCH - SHORTNAME2WEB4EIGHT: ", shortname2web4eight)
                # 
                
            ackall2found4eight = False 
            while 1:
                if ackall2found4eight is True:
                    break
                else:
                    index2left4eight=str.find(shortname2web4eight,left2find4eight)
                    if index2left4eight == -1:
                        current2series4eight = shortname2web4eight
                        if ack2debug4eight is True:
                            print("(STEP 2A/33) OF SHOOT2EIGHT4SEARCH - CURRENT2SERIES4EIGHT: ", current2series4eight) 
                            # 
                        ackall2found4eight = True
                         
                    else:
                        index2right4eight=str.find(shortname2web4eight,right2find4eight)
                        if index2right4eight == -1:
                            ackall2found4eight = True 
                        else:
                            candidate2series4eight = shortname2web4eight[0:index2left4eight]
                            
                            index3find4eight=str.find(shortname2web4eight,current2series4eight)
                            if index3find4eight == -1:
                                
                                current2series4eight = candidate2series4eight
                                if ack2debug4eight is True:
                                    print("(STEP 2B/33) OF SHOOT2EIGHT4SEARCH - CURRENT2SERIES4EIGHT: ", current2series4eight) 
                                    # 
                                
                                count2short4eight = 0
                                fileobject4eight.write('<br />' + '\n')
                            else:
                                shortname2web4eight = shortname2web4eight[index2left4eight:index2right4eight+1]
                                if ack2debug4eight is True:
                                    print("(STEP 2C/33) OF SHOOT2EIGHT4SEARCH - SHORTNAME2WEB4EIGHT: ", shortname2web4eight)
                                    # 
                                
                                count2short4eight = count2short4eight + 1
                                if count2short4eight >= max2short4eight:
                                    count2short4eight = 0
                                else:
                                    pass       
                            ackall2found4eight = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4eight is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4eight.write('<br /><b>&raquo;</b><a href="' + url2web4eight + '" target="_blank">' + shortname2web4eight + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4eight = eight2analyse4search
                if ack2debug4eight is True:
                    print("(STEP 3A/33) OF SHOOT2EIGHT4SEARCH - BASE2LOCAL4EIGHT: ", base2local4eight)
                    #              
                ack2localtries4eight = False                   
                while 1:
                    if ack2localtries4eight is True:
                        break
                    else:
                        index2find4eight=str.find(url2web4eight,base2local4eight)            
                        # 
                        #  
                        if index2find4eight == -1:
                            ack2localtries4eight = True
                        else:
                            if ack2debug4eight is True:
                                print("(STEP 3B/33) OF SHOOT2EIGHT4SEARCH - BASE2BUILD4EIGHT: ", base2build4eight)
                                # 
                            url2web4eight = base2build4eight + url2web4eight[len(base2local4eight):]
                            if ack2debug4eight is True:
                                print("(STEP 3C/33) OF SHOOT2EIGHT4SEARCH - URL2WEB4EIGHT: ", url2web4eight)
                                # 
                            
                            if count2short4eight < 1: 
                                fileobject4eight.write('<br /><b>&raquo;</b><a href="' + url2web4eight + '" target="_blank">' + shortname2web4eight + '</a>' + '\n')
                            else:
                                fileobject4eight.write('<b>&raquo;</b><a href="' + url2web4eight + '" target="_blank">' + shortname2web4eight + '</a>\n')                            
                            ack2localtries4eight = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2EIGHT4SEARCH FAILED, FILEOBJECT4EIGHT-WRITE-FAILED: ", str(fileobject4eight), time4xi())
      
    else:
        
        count2nack4eight = count2nack4eight + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2eight4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2eight4search(queue2eight = None, consumer_channel2eight = None, publisher_channel2eight = None, path2eight = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4eight
    global count2nack4eight
    global count2found4eight
    
    global fileobject4eight    
    
    global maxsize2ack4eight    
    global meansize2ack4eight
    global minsize2ack4eight
    global sumsize2ack4eight    
    
    global maxsize2file4eight 
    
    global profile2fetch4eight                         # extension for files
    global keys2profile4eight
    global key2profile4eight

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2EIGHT4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2EIGHT4SEARCH -  QUEUE2EIGHT: ", queue2eight)      
    # QUEUE2EIGHT:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2EIGHT4SEARCH -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
    # CONSUMER_CHANNEL2EIGHT:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2EIGHT4SEARCH -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
    # PUBLISHER_CHANNEL2EIGHT:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2eight is None) or (consumer_channel2eight is None) or (publisher_channel2eight is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2EIGHT4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2EIGHT4SEARCH - QUEUE2EIGHT: ", queue2eight)
        print("(STEP 1C/33) OF SHOOT2EIGHT4SEARCH - CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight) 
        print("(STEP 1D/33) OF SHOOT2EIGHT4SEARCH - PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)
        print("(STEP 1E/33) OF SHOOT2EIGHT4SEARCH - PATH2EIGHT: ", path2eight)     
        
        return
 
    if (not (queue2eight is None) and not(consumer_channel2eight is None) and not(publisher_channel2eight is None) and (path2eight is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2EIGHT4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2EIGHT4SEARCH - QUEUE2EIGHT: ", queue2eight)
        print("(STEP 2C/33) OF SHOOT2EIGHT4SEARCH - CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight) 
        print("(STEP 2D/33) OF SHOOT2EIGHT4SEARCH - PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)
        print("(STEP 2E/33) OF SHOOT2EIGHT4SEARCH - PATH2EIGHT: ", path2eight)     
        return           

    if (not (queue2eight is None) and not(consumer_channel2eight is None) and not(publisher_channel2eight is None) and not(path2eight is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2EIGHT4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2EIGHT4SEARCH - QUEUE2EIGHT: ", queue2eight)
        # QUEUE2EIGHT:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2EIGHT4SEARCH - CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # CONSUMER_CHANNEL2EIGHT:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2EIGHT4SEARCH - PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)
        # PUBLISHER_CHANNEL2EIGHT:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2EIGHT4SEARCH - PATH2EIGHT: ", path2eight)
        # PATH2EIGHT:  F://temp//yophotos//test2eight//
       
        print("(STEP 4A/33) OF SHOOT2EIGHT4SEARCH - STARTING TO WALK PATH2EIGHT: ", path2eight)   
        # STARTING TO WALK PATH2EIGHT:  F://temp//yophotos//test2eight//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4eight = None
        try:
            name2index4eight = "index2xxxxxxxx4yo.html"
            path2index4eight = path2eight + name2index4eight
            print("(Step 4B/33) OF SHOOT2EIGHT4SEARCH - SET PATH2INDEX4EIGHT TO: ", path2index4eight)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4EIGHT: ", path2index4eight)          
            #                    
        fileobject4eight = None
        try:
            fileobject4eight = open(path2index4eight,'w')
            print("(Step 4C/33) OF SHOOT2EIGHT4SEARCH - OPENED OUTPUT: ", fileobject4eight)
            # OPENED OUTPUT:  <_io.TextIOWrapper name='O://temp//yophotos//test2eight//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4eight)         
            # 
        try:                
            fileobject4eight.write('<html>\n')
            
            fileobject4eight.write('<style type="text/css" media="all">\n')
            fileobject4eight.write(' @import "http://www.youreightxi.org/css/halongbay.css";\n')
            fileobject4eight.write('</style> \n')
            fileobject4eight.write('<p>\n')
            fileobject4eight.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4eight.write('<br /><a id="000">youreight<b>&Xi;</b> @Content</a>\n')
            fileobject4eight.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4eight.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4eight)         
            #      
        
        
        KB2name4eight = {}
        key2name4eight = 0
                 
        for file2walk in DirectoryWalker(path2eight):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4eight [key2name4eight] = file2walk
                    print ("KB2NAME4EIGHT[", key2name4eight, "]: ", KB2name4eight [key2name4eight])
                    # 
                    
                    key2name4eight = key2name4eight + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2EIGHT4SEARCH - FAILED UPDATING KB2NAME4EIGHT WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4eight(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4eight.write('<br /> \n')
            fileobject4eight.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4eight.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4eight.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4eight.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4eight.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4eight.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4eight.write('</p>\n')
            # 
            fileobject4eight.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4eight)         
            #            
        try:    
            fileobject4eight.close()
            print("(Step 4C/33) OF SHOOT2EIGHT4SEARCH - CLOSED OUTPUT: ", fileobject4eight)         
            #    
        except:
            print("(Step 4Z5/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4eight)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2EIGHT4SEARCH - STARTING TO ANALYSE KB2NAME4EIGHT: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4EIGHT:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4eight  = {}
        AlphaKB4eight['a'] = {}
        AlphaKB4eight['b'] = {}
        AlphaKB4eight['c'] = {}
        AlphaKB4eight['d'] = {}
        AlphaKB4eight['e'] = {}
        AlphaKB4eight['f'] = {}
        AlphaKB4eight['g'] = {}
        AlphaKB4eight['h'] = {}
        AlphaKB4eight['i'] = {}
        AlphaKB4eight['j'] = {}
        AlphaKB4eight['k'] = {}
        AlphaKB4eight['l'] = {}
        AlphaKB4eight['m'] = {}
        AlphaKB4eight['n'] = {}
        AlphaKB4eight['o'] = {}
        AlphaKB4eight['p'] = {}
        AlphaKB4eight['q'] = {}
        AlphaKB4eight['r'] = {}
        AlphaKB4eight['s'] = {}
        AlphaKB4eight['t'] = {}
        AlphaKB4eight['u'] = {}
        AlphaKB4eight['v'] = {}
        AlphaKB4eight['w'] = {}
        AlphaKB4eight['x'] = {}
        AlphaKB4eight['y'] = {}
        AlphaKB4eight['z'] = {} 
        keys2AlphaKB4eight = AlphaKB4eight.keys()
        key2AlphaKB4eight  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4eight = len(path2eight)
        # 
        
        keys2name4eight = KB2name4eight.keys()
                
        for key2name4eight in sorted(keys2name4eight):
            # 
            name2optimize4eight = KB2name4eight[key2name4eight]
            # 
            shortcut2level4eight = name2optimize4eight[len2cut4eight:]
            # 
            len2shortcut4eight = len(shortcut2level4eight)
            if len2shortcut4eight == 1:
                try:
                    # LEVEL EIGHT CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4eight in keys2AlphaKB4eight:
                        KB2level1[key2level1] = shortcut2level4eight
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2EIGHT4SEARCH ** WARNING - SHORTCUT2LEVEL4EIGHT: ", shortcut2level4eight, " NOT IN KEYS2ALPHAKB4EIGHT: ", keys2AlphaKB4eight)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2EIGHT4SEARCH *** FAILED - SHORTCUT2LEVEL4EIGHT: ", shortcut2level4eight)      
            else:
                try:
                    
                    string2search4eight = '\\'
                    shortcut2level4eight = shortcut2level4eight[2:]
                    
                    index2level4eight=str.find(shortcut2level4eight,string2search4eight)
                    if index2level4eight == -1:
                         
                        KB2level2[key2level2] = shortcut2level4eight
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4eight = shortcut2level4eight[index2level4eight+1:]
                        index2level4eight=str.find(shortcut2level4eight,string2search4eight)
                        if index2level4eight == -1:
                            KB2level3[key2level3] = shortcut2level4eight
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4eight = shortcut2level4eight[index2level4eight+1:]
                            index2level4eight=str.find(shortcut2level4eight,string2search4eight)
                            if index2level4eight == -1:
                                KB2level4[key2level4] = shortcut2level4eight
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4eight = shortcut2level4eight[index2level4eight+1:]
                                index2level4eight=str.find(shortcut2level4eight,string2search4eight)
                                if index2level4eight == -1:
                                    KB2level5[key2level5] = shortcut2level4eight
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4eight = shortcut2level4eight[index2level4eight+1:]
                                    index2level4eight=str.find(shortcut2level4eight,string2search4eight)
                                    if index2level4eight == -1:
                                        KB2level6[key2level6] = shortcut2level4eight
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4eight = shortcut2level4eight[index2level4eight+1:]
                                        index2level4eight=str.find(shortcut2level4eight,string2search4eight)
                                        if index2level4eight == -1:
                                            KB2level7[key2level7] = shortcut2level4eight
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4eight = shortcut2level4eight[index2level4eight+1:]
                                            index2level4eight=str.find(shortcut2level4eight,string2search4eight)
                                            if index2level4eight == -1:
                                                KB2level8[key2level8] = shortcut2level4eight
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2EIGHT4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4EIGHT: ", shortcut2level4eight)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2EIGHT4SEARCH *** FAILED - SHORTCUT2LEVEL4EIGHT: ", shortcut2level4eight)   
        
        print ("(Step 6A/33) OF SHOOT2EIGHT4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2EIGHT4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2EIGHT4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2EIGHT4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # eightfly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2EIGHT4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2EIGHT4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2EIGHT4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2EIGHT4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2EIGHT4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2EIGHT4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2EIGHT4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2EIGHT4SEARCH - COUNT2ACK4EIGHT; ", count2ack4eight)
            # COUNT2ACK4EIGHT;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2EIGHT4SEARCH - COUNT2NACK4EIGHT; ", count2nack4eight)
            # COUNT2NACK4EIGHT;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2EIGHT4SEARCH - COUNT2FOUND4EIGHT: ", count2found4eight)
            # COUNT2FOUND4EIGHT:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2EIGHT4SEARCH - FOUND MAX SIZE: ", maxsize2ack4eight)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2EIGHT4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4eight)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4eight == 0:
                meansize2ack4eight = 0
                print ("(Step 7G1/33) OF SHOOT2EIGHT4SEARCH - MEAN SIZE SET: ", meansize2ack4eight)
                #  
            else:       
                meansize2ack4eight = int(sumsize2ack4eight / count2ack4eight)
                print ("(Step 7G2/33) OF SHOOT2EIGHT4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4eight, ", WHERE SUMSIZE2ACK4EIGHT: ", sumsize2ack4eight, " COUNT2ACK4EIGHT: ", count2ack4eight)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4EIGHT:  10944512  COUNT2ACK4EIGHT:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4eight < maxsize2file4eight:
                print ("(Step 7H/33) OF SHOOT2EIGHT4SEARCH - MIN SIZE MET: ", minsize2ack4eight)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2EIGHT4SEARCH ** MIN DEFINED: ", minsize2ack4eight, " EQUALS TO MAXSIZE2FILE4EIGHT: ", maxsize2file4eight)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2EIGHT4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2EIGHT4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2EIGHT4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2EIGHT4SEARCH - QUEUE2EIGHT: ", queue2eight)
        print("(STEP 7Z3/33) OF SHOOT2EIGHT4SEARCH - CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight) 
        print("(STEP 7Z4/33) OF SHOOT2EIGHT4SEARCH - PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)
        print("(STEP 7Z5/33) OF SHOOT2EIGHT4SEARCH - PATH2EIGHT: ", path2eight)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.eightxi.com; www.youreightxi.com; www.youreightxi.org; www.eight2xi.com/; www.eight4xi.com/; www.eight8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2eight4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
